#import "mainController.h"
#import "gsmsalg.h"
#import "handoffs.h"
#import <sys/socket.h>
#import <sys/types.h>
#import <arpa/inet.h>
#import <sys/time.h>
#import <netdb.h>
#import <time.h>
#import <fcntl.h>
#import <netinet/in.h>
//#import <netinet/ip.h>
#import <netinet/udp.h>
//#import <netinet/ip_icmp.h>

#define GAMESPY "master.gamespy.com"
#define BUFSIZE 1460
#define GSSTATUS "\\info\\"
#define GSSTATUS1 "\\status\\"
#define MAX_BUF_SIZE 100000

#define Q3STATUS "\xff\xff\xff\xffgetstatus"
#define GETSTATUS_RESPONSE "\xff\xff\xff\xffstatusResponse"

#define Q3DETAILS "\xff\xff\xff\xffgetstatus"

@implementation mainController

- (IBAction)getServersButton:(id)sender
{
    //strcpy(gameType, "halor");
    //strcpy(handoff, HALO);
    ///strcpy(gameType, "ut");
    //strcpy(handoff, UT);
    //strcpy(currentEngine, "gs");
    if([[getButton title] isEqualToString:@"Get Servers"]) {
    if([gameListBox indexOfSelectedItem] == -1) {
        [self standardError:@"Get Servers Error" error:@"Please choose a game before attempting to retrieve a list"];
        return;
    }
    
    [games removeAllObjects];
    [tableView reloadData];
    
    id theRecord;
    theRecord = [games_list objectAtIndex:[gameListBox indexOfSelectedItem]];
    strcpy(gameName, [[theRecord objectForKey:@"gamename"] cString]);
    strcpy(handoff, [[theRecord objectForKey:@"handoff"] cString]);
    strcpy(currentEngine, [[theRecord objectForKey:@"query_type"] cString]);
    strcpy(gameType, [[theRecord objectForKey:@"gametype"] cString]);
    current_object = games;
    stopThread = NO;
    [NSThread detachNewThreadSelector:@selector(getServers)
    toTarget:self withObject:nil];
    [getButton setTitle:@"Stop"];
   // [self queryGamespyServer:"24.30.114.88" port:1337];
    //[self queryGamespyServer:"168.215.229.76" port:2302];
    }
    else {
        NSLock *lock = [[NSLock alloc] init];
        [lock tryLock];
        stopThread = YES;
        [lock unlock];
        //try to stop thread
    }
}

- (void)windowWillClose:(NSNotification *)aNotification
{
    //NSLog(@"window will close");
    NSString *path = [[NSString alloc] init];
    path = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    path = [path stringByAppendingString:@"/favorites.plist"];
    [favorites writeToFile:path atomically:YES];
}

- (IBAction)addFavButton:(id)sender
{
   // NSLog(@"add fav");
    if([tableView selectedRow] == -1) return;
    id obj;
    obj = [games objectAtIndex:[tableView selectedRow]];
    [favorites addObject:obj];
    [favoritesView reloadData];
}
- (IBAction)removeFav:(id)sender
{
    if([favoritesView selectedRow] == -1) return;
    [favorites removeObjectAtIndex:[favoritesView selectedRow]];
    [favoritesView reloadData];
}
- (void)loadFavorites
{
    NSString *path = [[NSString alloc] init];
    path = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    path = [path stringByAppendingString:@"/favorites.plist"];
    favorites = [[NSMutableArray alloc] initWithContentsOfFile:path];
    if([favorites count] == 0) {
        favorites = [[NSMutableArray alloc] initWithCapacity:500];
        return;
    }
    [favoritesView reloadData];
}

- (void)standardError:(NSString*)smallError error:(NSString*)bigError
{
        NSAlert *alert = [[NSAlert alloc] init];
        [alert addButtonWithTitle:@"OK"];
        [alert setMessageText:smallError];
        [alert setInformativeText:bigError];
        [alert setAlertStyle:NSWarningAlertStyle];
        [alert runModal];
        [alert release];
}

- (void)loadGames
{
    NSString *path = [[NSString alloc] init];
    path = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    path = [path stringByAppendingString:@"/games.plist"];
    games_list = [[NSMutableArray alloc] initWithContentsOfFile:path];
    if([games_list count] == 0) return;
    
    [self addGamesToList];
    
}

- (void)addGamesToList
{
    [gameListBox setDataSource:self];
    [gameListBox reloadData];
    int x;
    id theRecord;
    for(x = 0; x < [games_list count]; x++) {
        theRecord = [games_list objectAtIndex:x];
        
    }
}

- (void)tableViewSelectionDidChange:(NSNotification *)aNotification
{
    id obj;
    id record;
    if([aNotification object] == tableView) {
        if([tableView selectedRow] == -1) return;
        current_tv = games;
        obj = [tableView selectedRow];
        //   [NSThread detachNewThreadSelector:@selector(getGamespyDetails:)
       // toTarget:self withObject:obj];
    record = [games objectAtIndex:obj];
    if([[record objectForKey:@"type"] isEqualToString:@"gs"]) {
     [self getGamespyDetails:[tableView selectedRow]];
     }
    else if([[record objectForKey:@"type"] isEqualToString:@"q3"]) {
     [self getq3details:[tableView selectedRow]];
     }
    }
    else if([aNotification object] == favoritesView) {
        if([favoritesView selectedRow] == -1) return;
        current_tv = favorites;
        obj = [favoritesView selectedRow];
       //    [NSThread detachNewThreadSelector:@selector(getGamespyDetails:)
       // toTarget:self withObject:obj];
    record = [favorites objectAtIndex:obj];
    if([[record objectForKey:@"type"] isEqualToString:@"gs"]) {
     [self getGamespyDetails:[favoritesView selectedRow]];
     }
    else if([[record objectForKey:@"type"] isEqualToString:@"q3"]) {
     [self getq3details:[favoritesView selectedRow]];
     }
    }
}

- (IBAction)refreshServersButton:(id)sender
{
    int tab;
    tab = [tabView indexOfTabViewItem:[tabView selectedTabViewItem]];
    if(tab == 0) {
        current_object = games;
        refreshing = YES;
       // [NSThread detachNewThreadSelector:@selector(refreshList:)
        //toTarget:self withObject:games];
        [self refreshList:games];
    }
    else if(tab == 1) {
    current_object = favorites;
    refreshing = YES;
     //      [NSThread detachNewThreadSelector:@selector(refreshList:)
      //  toTarget:self withObject:favorites];
   [self refreshList:favorites];
   }
   //refreshing = NO;
   /* int sock;
    struct sockaddr_in host;
    struct packet {
        struct icmp icmpHeader;
        struct timeval packetTimeStamp;
    };
    
    struct timeval pingTimeout;

    if((sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_ICMP)) == -1) {
        NSLog(@"Non-Privileged User");
    }
    
    host.sin_family = AF_INET;
    host.sin_addr.s_addr = inet_addr("69.56.194.242");
    host.sin_port = 2560;
    
    pingTimeout.tv_sec = 1;
    pingTimeout.tv_usec = 0;
    
    setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, 
                        &pingTimeout, sizeof(pingTimeout));
                        
    struct packet ICMPPacket;
    
    ICMPPacket.icmpHeader.icmp_type = ICMP_ECHO;
    ICMPPacket.icmpHeader.icmp_code = 0;*/


}

- (void)refreshList:(id)object
{
NSAutoreleasePool *pool =[[NSAutoreleasePool alloc] init];
    NSLock *lock = [[NSLock alloc] init];
    int cur_servers;
    int x;
    unsigned short port;
    char *ip = (char*)malloc(32);
    NSTableView *tv;
    if(object == favorites) {
        tv = favoritesView;
    }
    //update informative texts
    [lock tryLock];
    [statusText setStringValue:[NSString stringWithFormat:@"Refreshing %d servers...", [object count]]];
    [lock unlock];
    int type;
    queried = 0;
    int y;
    unsigned int timestamp, timestamp1;
    char ip_str[256];
    id theRecord;
    for(x = 0; x < [object count]; x++) {
        
        theRecord = [object objectAtIndex:x];
        strcpy(ip_str, [[theRecord objectForKey:@"ip"] cString]);
    
        for(y = 0; ip_str[y] != ':'; y++) {
            ip[y] = ip_str[y];
        }
        ip[y] = 0;
        port = atoi(ip_str+(y+1));
        //NSLog(@"IP: %s:%u",ip, port);
        if(strcmp([[theRecord objectForKey:@"type"] cString], "gs") == 0) type = 1;
        if(strcmp([[theRecord objectForKey:@"type"] cString], "q3") == 0) type = 2;
        if(type == 1) {
            [self queryGamespyServer:ip port:port];
        }
        else if(type == 2) {
            [self queryq3Server:ip port:port];
        }
        usleep(6000);
        
    }
    
        NSLock *lock1 = [[NSLock alloc] init];
    [lock1 tryLock];
    [statusText setStringValue:@"Inactive"];
    [lock1 unlock];
   // [pool release];
    //refreshing = NO;
    
   // [lock unlock]; //release thread
    //[tableView reloadData];
}

- (void)getServers
{
    NSAutoreleasePool *pool =[[NSAutoreleasePool alloc] init];
    int sockfd, ret;
    struct hostent *host;
    struct sockaddr_in remote;
    char *packet = (char*)malloc(10000000);
    int pos;
    char *buf = (char*)malloc(BUFSIZE);

    sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_IP);

    host = gethostbyname(GAMESPY);

    remote.sin_family = AF_INET;
    remote.sin_port = htons(28900);
    remote.sin_addr.s_addr = *(unsigned long *)(host->h_addr);

    [statusText setStringValue:@"Querying Master Server..."];
    connect(sockfd, (struct sockaddr*)&remote, sizeof(remote));

    ret = recv(sockfd, buf, BUFSIZE, 0);
    buf++;
    for(;*buf!=0x5C;buf++);
    buf++;
    for(;*buf!=0x5C;buf++);
    buf++;
    for(;*buf!=0x5C;buf++);
    buf++;
    unsigned char *response = gsseckey((unsigned char*)buf, (unsigned char*)handoff, 0);
    char query[512];
    int len;
    len = sprintf(query, "\\basic\\gamename\\%s\\location\\0\\validate\\%s\\final\\list\\cmp\\gamename\\%s\\gametype\\%s\\final\\", gameName,response,gameName, gameType);
    //NSLog(@"%s", query);
    send(sockfd, query, len, 0);
    pos = 0;
    while(ret>0)
    {
        ret = recv(sockfd, buf, BUFSIZE, 0);
        if(ret > 0)
        {
            memcpy(packet+pos, buf, ret);
            pos += ret;
        }
    }
    //[statusText setStringValue:@"Parsing IP List..."];
    packet[pos] = 0;
    //NSLog(@"%d", pos);
    [self queryGamespyList:packet length:pos];
    //[self parseIPList:packet];
    free(packet);
    NSLock *lock1 = [[NSLock alloc] init];
    [lock1 tryLock];
    [statusText setStringValue:@"Inactive"];
    
    [getButton setTitle:@"Get Servers"];
    [lock1 unlock];
    [pool release];
}

- (void)queryGamespyList:(unsigned char *)packet length:(int)len
{
    NSLock *lock = [[NSLock alloc] init];
    int cur_servers;
    int x;
    unsigned short port;
    char *ip = (char*)malloc(32);
    //[lock tryLock]; //lock our thread
    
    //get total servers
    cur_servers =  (len-1)/6;
    
    //update informative texts
    //[totalServers setStringValue:[NSString stringWithFormat:@"%d",cur_servers]];
    [lock tryLock];
    [statusText setStringValue:[NSString stringWithFormat:@"Querying %d servers...", cur_servers]];
    [lock unlock];

    int batch;
    batch = cur_servers / 20;
    int cur;
    cur = 0;
    queried = 0;
    int speed;
    unsigned int timestamp, timestamp1;
    int type;
    if(strcmp(currentEngine, "gs") == 0) type = 1;
    if(strcmp(currentEngine, "q3") == 0) type = 2;
    for(x = 0; x < cur_servers; x++) {
        
        port = packet[4] << 8 | packet[5];
       
        
         
        sprintf(ip, "%d.%d.%d.%d", packet[0], packet[1], packet[2], packet[3]);
        //NSLog(@"IP: %s:%u",ip, port);
        if(type == 1) {
        [self queryGamespyServer:ip port:port];
        }
        else if(type == 2) {
        [self queryq3Server:ip port:port];
        }

        speed = 100000 - [querySpeed intValue];
        //NSLog(@"%d %d",[querySpeed intValue], speed);

        usleep(speed);
        
        //move to next set of ips
        packet += 6;
        cur++;
        if(stopThread == YES) {
            break;
        }
    }
    [lock lock];
    stopThread = NO;
    
    [getButton setTitle:@"Get Servers"];
    [lock unlock];
    

   // [lock unlock]; //release thread
    //[tableView reloadData];
}

- (NSComparisonResult)compare:(id)other
{
    //NSLog(@"compare");
}

- (void)checkForData
{
    /*char *buf = NULL;
    buf = (char*)malloc(MAX_BUF_SIZE);
    int ret;
    int addrlen;
    char ip[32];
    unsigned short port;
    struct sockaddr_in remote;
    NSLock *lock = [[NSLock alloc] init];
    addrlen = sizeof(struct sockaddr_in);
    ret = recvfrom(sockfd, buf, MAX_BUF_SIZE, 0, (struct sockaddr*)&remote, &addrlen);
   
    if(ret > 0) {
       // NSLog(@"%s", buf);
        buf[ret] = 0;
        queried++;
        [self parseGamespyInfoResponse:buf ip:inet_ntoa(remote.sin_addr) port:remote.sin_port];
    [lock tryLock];
            
        [tableView reloadData];
        [totalServers setStringValue:[NSString stringWithFormat:@"%d", queried]];
        [lock unlock];
    }
    if(buf != NULL) free(buf);*/
    
}

- (void)startListenServer
{
    NSAutoreleasePool *pool =[[NSAutoreleasePool alloc] init];
    int ret, addrlen;
    char *buf = NULL;
    buf = (char*)malloc(MAX_BUF_SIZE);
    struct sockaddr_in local, remote;
    
    /* select bs*/
    struct timeval timeout;
    fd_set readfds, masterfds;
    
    timeout.tv_sec = 1;                    /*set the timeout to 10 seconds*/

    timeout.tv_usec = 0;
    
    
    
    sockfd = socket(AF_INET, SOCK_DGRAM, 0);
    
    /*FD_ZERO(&masterfds);
    FD_SET(sockfd, &masterfds);

    memcpy(&readfds, &masterfds, sizeof(fd_set));

   if (select(sockfd+1, &readfds, NULL, NULL, &timeout) < 0)*/
    //fd_set masterfds, readfds;
    //fcntl(sockfd, F_SETFL, O_NONBLOCK);
    local.sin_family = AF_INET;
    local.sin_port = htons(rand());
    local.sin_addr.s_addr = INADDR_ANY;
    bind(sockfd, (struct sockaddr*)&local, sizeof(local));
    
    NSLock *lock = [[NSLock alloc] init];
    addrlen = sizeof(struct sockaddr_in);
        
    FD_ZERO(&masterfds);
    FD_SET(sockfd, &masterfds);

    memcpy(&readfds, &masterfds, sizeof(fd_set));
    id theObject;
    for(;;) {

    
   // if (select(sockfd+1, &readfds, NULL, NULL, &timeout) < 0) {
   //     return;
  // }
  // if(FD_ISSET(sockfd, &readfds)) {
    
    ret = recvfrom(sockfd, buf, MAX_BUF_SIZE, 0, (struct sockaddr*)&remote, &addrlen);
     if(ret > 0) {
       // NSLog(@"%s", buf);
        buf[ret] = 0;
        queried++;
       if( [lock tryLock]) {
        theObject = current_object;
        [lock unlock];
        }
        if(strncmp(buf, GETSTATUS_RESPONSE, strlen(GETSTATUS_RESPONSE)) == 0) {
            //NSLog(@"%s", buf);
            
            [self parseq3InfoResponse:buf ip:inet_ntoa(remote.sin_addr) port:remote.sin_port obj:theObject];
        }
        else {
        [self parseGamespyInfoResponse:buf ip:inet_ntoa(remote.sin_addr) port:remote.sin_port obj:theObject];
        }
        if([lock tryLock]) {
            
        if(theObject == games) [tableView reloadData];
        if(theObject == favorites) [favoritesView reloadData];
        [totalServers setStringValue:[NSString stringWithFormat:@"%d", queried]];
        [lock unlock];
        }
        //} 
     //   else {
        
    //    }
    }
    
    }//for loop
    if(buf != NULL) free(buf);
    [pool release];

}

- (void)queryq3Server:(char*)ip port:(unsigned short)port
{
    int ret; 
    struct sockaddr_in host;
    host.sin_family = AF_INET;
    host.sin_addr.s_addr = inet_addr(ip);
    host.sin_port = htons(port);

    ret = sendto(sockfd, Q3STATUS, strlen(Q3STATUS), 0, (struct sockaddr*)&host, sizeof(host));
    
    
}

- (void)queryGamespyServer:(char*)ip port:(unsigned short)port
{
    int ret; 
    struct sockaddr_in host;
    host.sin_family = AF_INET;
    host.sin_addr.s_addr = inet_addr(ip);
    host.sin_port = htons(port);

    ret = sendto(sockfd, GSSTATUS, strlen(GSSTATUS), 0, (struct sockaddr*)&host, sizeof(host));
    
    
}

- (void)parseGamespyInfoResponse:(char*)buf ip:(char*)ip port:(unsigned short)port obj:(id)object
{
    //NSLog(@"%s", buf);
    int x, len;
    char command[256], value[512];
    int numplayers, maxplayers;
    numplayers = -1;
    NSMutableDictionary *dic = [[NSMutableDictionary alloc] init];
    [dic setObject:[NSString stringWithFormat:@"%s:%u", ip,port] forKey:@"ip"];
    /* Begin Parsing */
    [dic setObject:@"gs" forKey:@"type"];
    for(;strncmp(buf, "\\final\\", 7) != 0;) {
        buf++;
        //get option
        len = [self handleDelim:buf];
        memcpy(command, buf, len);
        command[len] = 0;
        buf += strlen(command) + 1;
        //get value
        len = [self handleDelim:buf];
        memcpy(value, buf, len);
        value[len] = 0;
        buf += strlen(value);
       // NSLog(@"%s:%s", command, value);
        if(strcmp(command, "hostname") == 0) { //hostname
            [dic setObject:[NSString stringWithFormat:@"%s", value] forKey:@"name"];
        }
        else if(strcmp(command, "mapname") == 0) { //map name
            [dic setObject:[NSString stringWithFormat:@"%s", value] forKey:@"map"];
        }
        else if(strcmp(command, "numplayers") == 0) { //map name
            numplayers = atoi(value);
        }
        else if(strcmp(command, "maxplayers") == 0) { //map name
            maxplayers = atoi(value);
        }
    }
    if(numplayers >= 0 && maxplayers > 0) {
        [dic setObject:[NSString stringWithFormat:@"%d/%d", numplayers, maxplayers] forKey:@"players"];
    }
    char ip_str[256];
    NSLock *lock = [[NSLock alloc] init];
    bool refresh;
    [lock tryLock];
    refresh = refreshing;
    [lock unlock];
    bool found;
    id theRecord;
    //if(refresh == YES) {
        sprintf(ip_str, "%s:%u", ip, port);
        found = NO;
        for(x = 0; x < [object count]; x++) {
            theRecord = [object objectAtIndex:x];
            if(strcmp(ip_str, [[theRecord objectForKey:@"ip"] cString]) == 0) { //found
                [object replaceObjectAtIndex:x withObject:dic];
                //NSLog(@"found row");
                found = YES;
                break;
            }
        
        }
        if(found == NO) [object addObject:dic];
   /* }
    else {
        [object addObject:dic];
    }*/
    
}

- (void)parseq3InfoResponse:(char*)buf ip:(char*)ip port:(unsigned short)port obj:(id)object
{
    //NSLog(@"%s", buf);
    int x, len;
    char command[256], value[512];
    int numplayers, maxplayers;
    numplayers = -1;
    NSMutableDictionary *dic = [[NSMutableDictionary alloc] init];
    [dic setObject:[NSString stringWithFormat:@"%s:%u", ip,port] forKey:@"ip"];
    [dic setObject:@"q3" forKey:@"type"];
    char hostname1[512];
   // NSLog(@"%s", buf);
    /* Begin Parsing */
    buf += 19;
    for(;*buf != 0x0A;) {
        buf++;
        //get option
        len = [self handleDelim:buf];
        memcpy(command, buf, len);
        command[len] = 0;
        buf += strlen(command) + 1;
        //get value
        len = [self handleDelim:buf];
        memcpy(value, buf, len);
        value[len] = 0;
        buf += strlen(value);
       // NSLog(@"%s:%s", command, value);
        if(strcmp(command, "sv_hostname") == 0) { //hostname
            
            strcpy(hostname1, value);
        }
        else if(strcmp(command, "mapname") == 0) { //map name
            [dic setObject:[NSString stringWithFormat:@"%s", value] forKey:@"map"];
        }
        else if(strcmp(command, "g_needpass") == 0) { //lock
            if(strcmp(value, "1") == 0) [dic setObject:@"Yes" forKey:@"lock"];
        }
        else if(strcmp(command, "sv_maxclients") == 0) { //map name
            maxplayers = atoi(value);
        }
    }
    char hostname[512];
    int y;
    y= 0;
    for(x = 0; x < strlen(hostname1); x++) {
        if(hostname1[x] == 0x5E) {
            x++;
        }
        else {
            hostname[y] = hostname1[x];
            y++;
        }
    }
    hostname[y] = 0;
    [dic setObject:[NSString stringWithFormat:@"%s", hostname] forKey:@"name"];
    /* let's parse number of players */
    char nick[256];
    numplayers = 0;
    for(; *buf != 0;) {
        for(;*buf!=0x22;buf++) {
            if(*buf == 0x00) break;
        }
        buf++;
        len = [self handleDelim1:buf delim:'\x22'];
        memcpy(nick, buf, len);
        nick[len] = 0;
        buf += strlen(nick);
        if(*buf == 0x00) break;
        buf++;
        if(numplayers >= maxplayers) break;
        numplayers++;

    }
    if(numplayers >= 0 && maxplayers > 0) {
        [dic setObject:[NSString stringWithFormat:@"%d/%d", numplayers, maxplayers] forKey:@"players"];
    }
    char ip_str[256];
    NSLock *lock = [[NSLock alloc] init];
    bool refresh;
    [lock tryLock];
    refresh = refreshing;
    [lock unlock];
    bool found;
    id theRecord;
    //if(refresh == YES) {
        sprintf(ip_str, "%s:%u", ip, port);
        found = NO;
        for(x = 0; x < [object count]; x++) {
            theRecord = [object objectAtIndex:x];
            if(strcmp(ip_str, [[theRecord objectForKey:@"ip"] cString]) == 0) { //found
                [object replaceObjectAtIndex:x withObject:dic];
                //NSLog(@"found row");
                found = YES;
                break;
            }
        
        }
        if(found == NO) [object addObject:dic];
   /* }
    else {
        [object addObject:dic];
    }*/
    
}


- (void)getGamespyDetails:(int)index
{
   // NSAutoreleasePool *pool =[[NSAutoreleasePool alloc] init];
    NSLock *lock = [[NSLock alloc] init];
    /* clear current stuff */
   // [lock tryLock];
    [rules removeAllObjects];
    [rulesView reloadData];
    [players removeAllObjects];
    [playersView reloadData];
    //[lock unlock];
    /* get ip and port of row */
    id theRecord;
    char *ip = (char*)malloc(64);
    char ip_address[32];
    unsigned short port;
    int x;
    theRecord = [current_tv objectAtIndex:index];

    strcpy(ip, [[theRecord objectForKey:@"ip"] cString]);
    for(x = 0; ip[x] != ':'; x++)
    {
        ip_address[x] = ip[x];
    }
    ip_address[x] = 0;
    
    ip += strlen(ip_address) + 1;

    port = atoi(ip);
   // NSLog(@"IP: %s", ip_address);
   // NSLog(@"Port: %d", port);
    
    int ret, addrlen;
    int sock;
    char *buf = NULL;
    buf = (char*)malloc(MAX_BUF_SIZE);
    struct sockaddr_in local, remote;
    
    /* select bs*/
    struct timeval timeout;
    fd_set readfds, masterfds;
    
    timeout.tv_sec = 1;                    /*set the timeout to 10 seconds*/

    timeout.tv_usec = 0;
    
    
    
    sock = socket(AF_INET, SOCK_DGRAM, 0);
   // fcntl(sock, F_SETFL, O_NONBLOCK);
    
    remote.sin_family = AF_INET;
    remote.sin_port = htons(port);
    remote.sin_addr.s_addr = inet_addr(ip_address);
    
    sendto(sock, GSSTATUS1, strlen(GSSTATUS1), 0, (struct sockaddr*)&remote, sizeof(remote));
    
    addrlen = sizeof(remote);
    
    //ret = recvfrom(sockfd, buf, MAX_BUF_SIZE, 0, (struct sockaddr*)&remote, &addrlen);
    
    //NSLog(@"Buf: %s", buf);
    
    FD_ZERO(&masterfds);
    FD_SET(sock, &masterfds);

    memcpy(&readfds, &masterfds, sizeof(fd_set));
   int pos1;
   pos1 = 0;
   ret = 1;
   for(;;) {
   if (select(sock+1, &readfds, NULL, NULL, &timeout) < 0) {
        ret = -1;
        break;
   }
    if(FD_ISSET(sock, &readfds)) {
   ret = recvfrom(sock, buf+pos1, MAX_BUF_SIZE, 0, (struct sockaddr*)&remote, &addrlen);
   //NSLog(@"%d", ret);
   if(ret > 0) {
    pos1 += ret;
    buf[pos1] = 0;
    if(strstr(buf, "\\final\\")) break;
   }
   }
   else {
    NSLog(@"timeout");
    return;
    }
   //if(ret <= 0) return; //timeout
   }
    

    //NSLog(@"%s", buf);
    int len;
    char command[256], value[512];
    int numplayers, maxplayers;
    numplayers = -1;
    NSMutableDictionary *dic;
    NSMutableDictionary *dic1;
    bool found;
    found = NO;
    //NSLog(@"%s", buf);
    //[dic setObject:[NSString stringWithFormat:@"%s:%u", ip,port] forKey:@"ip"];
    NSLog(@"%s", buf);
    for(;strncmp(buf, "\\final\\", 7) != 0;) {
        if(*buf == 0) break;
        buf++;
        //get option
        len = [self handleDelim:buf];
        memcpy(command, buf, len);
        command[len] = 0;
        buf += strlen(command) + 1;
        //get value
        len = [self handleDelim:buf];
        memcpy(value, buf, len);
        value[len] = 0;
        buf += strlen(value);
        if(strstr(command, "player_f")) {
        
        }
        else if(strstr(command, "player_")) { //a player's name
            dic1 = [[NSMutableDictionary alloc] init];
            //NSLog(@"%d: %s",atoi(command+7), value); 
            found = NO;
            for(x = 0; x < [players count]; x++) { //see if this player has already been added
                theRecord = [players objectAtIndex:x];
                if(strcmp(command+7, [[theRecord objectForKey:@"player_index"] cString]) == 0) {
                    
                    [theRecord setObject:[NSString stringWithFormat:@"%s", value] forKey:@"player"];
                    [theRecord setObject:[NSString stringWithFormat:@"%s", command+7] forKey:@"player_index"];

                    found = YES;
                    [players replaceObjectAtIndex:x withObject:theRecord];
                    break;
                }
            }
            if(found == NO) {
                [dic1 setObject:[NSString stringWithFormat:@"%s", value] forKey:@"player"];
                [dic1 setObject:[NSString stringWithFormat:@"%s", command+7] forKey:@"player_index"];
                [players addObject:dic1];
            }
            
            [dic1 release];
        }
        else if(strstr(command, "ping_")) { //player's ping
            dic1 = [[NSMutableDictionary alloc] init];
            //NSLog(@"%d: %s",atoi(command+5), value); 
            found = NO;
            for(x = 0; x < [players count]; x++) { //see if this player has already been added
                theRecord = [players objectAtIndex:x];
                if(strcmp(command+5, [[theRecord objectForKey:@"player_index"] cString]) == 0) {
                    
                    [theRecord setObject:[NSString stringWithFormat:@"%s", value] forKey:@"ping"];
                    [theRecord setObject:[NSString stringWithFormat:@"%s", command+5] forKey:@"player_index"];
                    found = YES;
                    [players replaceObjectAtIndex:x withObject:theRecord];
                    break;
                }
            }
            if(found == NO) {
                [dic1 setObject:[NSString stringWithFormat:@"%s", value] forKey:@"ping"];
                [dic1 setObject:[NSString stringWithFormat:@"%s", command+5] forKey:@"player_index"];
                [players addObject:dic1];
            }
            [dic1 release];
        }
        else if(strstr(command, "frags_")) { //player's ping
            dic1 = [[NSMutableDictionary alloc] init];
           // NSLog(@"%d: %s",atoi(command+6), value); 
            found = NO;
            for(x = 0; x < [players count]; x++) { //see if this player has already been added
                theRecord = [players objectAtIndex:x];
                if(strcmp(command+6, [[theRecord objectForKey:@"player_index"] cString]) == 0) {
                    
                    [theRecord setObject:[NSString stringWithFormat:@"%s", value] forKey:@"frags"];
                    [theRecord setObject:[NSString stringWithFormat:@"%s", command+6] forKey:@"player_index"];
                    found = YES;
                    [players replaceObjectAtIndex:x withObject:theRecord];
                    break;
                }
            }
            if(found == NO) {
                [dic1 setObject:[NSString stringWithFormat:@"%s", value] forKey:@"frags"];
                [dic1 setObject:[NSString stringWithFormat:@"%s", command+6] forKey:@"player_index"];
                [players addObject:dic1];
            }
            [dic1 release];
        }

        else { //add to rules
        dic = [[NSMutableDictionary alloc] init];
        [dic setObject:[NSString stringWithFormat:@"%s", command] forKey:@"rule"];
        [dic setObject:[NSString stringWithFormat:@"%s", value] forKey:@"value"];
        [rules addObject:dic];
        [dic release];
        
        }
        
        
       
        
    }
    
    //[lock tryLock];
    [rulesView reloadData];
    [playersView reloadData];
    //[lock unlock];
    //[pool release];
}
- (void)getq3details:(int)index
{
   // NSAutoreleasePool *pool =[[NSAutoreleasePool alloc] init];
    NSLock *lock = [[NSLock alloc] init];
    /* clear current stuff */
   // [lock tryLock];
    [rules removeAllObjects];
    [rulesView reloadData];
    [players removeAllObjects];
    [playersView reloadData];
    //[lock unlock];
    /* get ip and port of row */
    id theRecord;
    char *ip = (char*)malloc(64);
    char ip_address[32];
    unsigned short port;
    int x;
    theRecord = [current_tv objectAtIndex:index];

    strcpy(ip, [[theRecord objectForKey:@"ip"] cString]);
    for(x = 0; ip[x] != ':'; x++)
    {
        ip_address[x] = ip[x];
    }
    ip_address[x] = 0;
    
    ip += strlen(ip_address) + 1;

    port = atoi(ip);
    //NSLog(@"IP: %s", ip_address);
    //NSLog(@"Port: %d", port);
    
    int ret, addrlen;
    int sock;
    char *buf = NULL;
    buf = (char*)malloc(MAX_BUF_SIZE);
    struct sockaddr_in local, remote;
    
    /* select bs*/
    struct timeval timeout;
    fd_set readfds, masterfds;
    
    timeout.tv_sec = 1;                    /*set the timeout to 10 seconds*/

    timeout.tv_usec = 0;
    
    
    
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    //fcntl(sock, F_SETFL, O_NONBLOCK);
    
    remote.sin_family = AF_INET;
    remote.sin_port = htons(port);
    remote.sin_addr.s_addr = inet_addr(ip_address);
    
    ret = sendto(sock, Q3DETAILS, strlen(Q3DETAILS), 0, (struct sockaddr*)&remote, sizeof(remote));
    //(@"sent data: %d", ret);
    addrlen = sizeof(remote);
    
    FD_ZERO(&masterfds);
    FD_SET(sock, &masterfds);

    memcpy(&readfds, &masterfds, sizeof(fd_set));
    
    if (select(sock+1, &readfds, NULL, NULL, &timeout) < 0) {
        return;
   }
   if(FD_ISSET(sock, &readfds)) {
    
    ret = recvfrom(sock, buf, MAX_BUF_SIZE, 0, (struct sockaddr*)&remote, &addrlen);
    //NSLog(@"Received Data: %d", ret);
    //NSLog(@"%s", buf);
    }
    else {
        NSLog(@"timed out :(");
        return;
    }
    int len;
    char command[256], value[512];
    int numplayers, maxplayers;
    numplayers = -1;
    NSMutableDictionary *dic;
    /* Begin Parsing */
    buf += 19;
    for(;*buf != 0x0A;) {
        buf++;
        //get option
        len = [self handleDelim:buf];
        memcpy(command, buf, len);
        command[len] = 0;
        buf += strlen(command) + 1;
        //get value
        len = [self handleDelim:buf];
        memcpy(value, buf, len);
        value[len] = 0;
        buf += strlen(value);
       // NSLog(@"%s:%s", command, value);
        dic = [[NSMutableDictionary alloc] init];
        [dic setObject:[NSString stringWithFormat:@"%s", command] forKey:@"rule"];
        [dic setObject:[NSString stringWithFormat:@"%s", value] forKey:@"value"];
        [rules addObject:dic];
        [dic release];
       
    }
    /* let's parse number of players */
    char nick[256];
    char nick1[256];
    char frags[32];
    char ping[32];
    numplayers = 0;
    for(; *buf != 0;) {
        buf++;
        dic = [[NSMutableDictionary alloc] init];
        len = [self handleDelim1:buf delim:'\x20'];
        memcpy(frags, buf, len);
        frags[len] = 0;
        buf += strlen(frags) + 1;
        //NSLog(@"%s", frags);
        [dic setObject:[NSString stringWithFormat:@"%s", frags] forKey:@"frags"];
        len = [self handleDelim1:buf delim:'\x20'];
        memcpy(ping, buf, len);
        ping[len] = 0;
        buf += strlen(ping) + 1;
        [dic setObject:[NSString stringWithFormat:@"%s", ping] forKey:@"ping"];
        for(;*buf!=0x22;buf++) {
            if(*buf == 0x00) break;
        }
        buf++;
        len = [self handleDelim1:buf delim:'\x22'];
        memcpy(nick, buf, len);
        nick[len] = 0;
        buf += strlen(nick) + 1;
        int y;
        y= 0;
        for(x = 0; x < strlen(nick); x++) {
        if(nick[x] == 0x5E) {
            x++;
        }
        else {
            nick1[y] = nick[x];
            y++;
        }
    }
    nick1[y] = 0;
        [dic setObject:[NSString stringWithFormat:@"%s", nick1] forKey:@"player"];
        [players addObject:dic];
        [dic release];

    }
    [rulesView reloadData];
    [playersView reloadData];
}


- (void)awakeFromNib
{
    games = [[NSMutableArray alloc] initWithCapacity:10000];
    rules = [[NSMutableArray alloc] initWithCapacity:300];
    players = [[NSMutableArray alloc] initWithCapacity:300];
    //favorites = [[NSMutableArray alloc] initWithCapacity:300];
    [self loadGames];
    [tableView setDelegate:self];
    [tableView setDataSource:self];
    [tableView setTarget:self];
    [rulesView setDelegate:self];
    [rulesView setDataSource:self];
    [rulesView setTarget:self];
    [thisWindow setDelegate:self];
    [playersView setDataSource:self];
    [self loadFavorites];
    [favoritesView setDataSource:self];
    [favoritesView setDelegate:self];
        [NSThread detachNewThreadSelector:@selector(startListenServer)
    toTarget:self withObject:nil];
    
}

- (void)parseIPList:(unsigned char*)packet
{
    NSMutableDictionary *dic;
    char ip[24];
    int len;
    for(;strncmp(packet, "\\final\\", 7) != 0;) {
        packet++;
        for(;*packet!=0x5C; packet++);
        packet++;
        dic = [[NSMutableDictionary alloc] init];
        len = [self handleDelim:packet];
        memcpy(ip, packet, len);
        ip[len] = 0;
        //NSLog(@"%s", ip);
        packet += len;
        [dic setObject:[NSString stringWithFormat:@"%s", ip] forKey:@"ip"];
        [games addObject:dic];
        [dic release];
        [tableView reloadData];
        
    }
    [statusText setStringValue:[NSString stringWithFormat:@"Querying %d servers...", [games count]]];
   // [self queryServers];
}

- (void)queryServers
{
    int sockfd;
    struct sockaddr_in host;
    unsigned short port;
    int y;
    char *buf = (char*)malloc(10000);
    char *ip = (char*)malloc(26);
    id theRecord;
    int pos, ret;
    char *ip1;
    int x;
    char *ip_address;
    NSLock *lock = [[NSLock alloc] init];
    [lock tryLock];
    ip_address = (char*)malloc(26);
    for(y = 0; y < [games count]; y++) {
    
    theRecord = [games objectAtIndex:y];

    strcpy(ip, [[theRecord objectForKey:@"ip"] cString]);
    for(x = 0; ip[x] != ':'; x++)
    {
        ip_address[x] = ip[x];
    }
    ip_address[x] = 0;
    
    ip += strlen(ip_address) + 1;

    port = atoi(ip);
   // NSLog(@"IP: %s", ip_address);
   // NSLog(@"Port: %d", port);
    }
    [lock unlock];

}

- (void)parseGamespy:(unsigned char*)array 
{
    int len;
    char name[256];
    NSMutableDictionary *dic = [[NSMutableDictionary alloc] init];
    for(;strncmp(array, "\\final\\", 7) != 0;) {
        array++;
        for(;*array !=0x5C;array++);
        array++;
        len = [self handleDelim:array];
        memcpy(name, array, len);
        array += len;
        [dic setObject:[NSString stringWithFormat:@"%s", name] forKey:@"name"];
            break;
    }
   // NSLog(@"%s", name);
    //[games addObject:dic];
}

- (int) handleDelim:(unsigned char*)packet
{
    int len;
    int x;
    x = 0;
    for(x = 0; packet[x] != 0x5C; x++) {
        if(packet[x] == 0x00) break;
        if(packet[x] == 0x0A) break;
        if(packet[x] == 0x22) break;
    }
    return x;

}


- (int) handleDelim1:(unsigned char*)packet delim:(char)delim
{
    int len;
    int x;
    x = 0;
    if(*packet == 0x00) return 0;
    for(x = 0; packet[x] != delim; x++) {
        if(packet[x] == 0x00) break;
    }
    return x;

}
/* Table View Stuff */
- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
    if(aTableView == tableView) return [games count];
    if(aTableView == rulesView) return [rules count];
    if(aTableView == gameListBox) return [games_list count];
    if(aTableView == playersView) return [players count];
    if(aTableView == favoritesView) return [favorites count];
}

- (int)numberOfItemsInComboBox:(NSComboBox *)aTableView
{
    if(aTableView == tableView) return [games count];
    if(aTableView == rulesView) return [rules count];
    if(aTableView == gameListBox) return [games_list count];
}

- (id)comboBox:(NSComboBox *)comboBox
    objectValueForItemAtIndex:(int)rowIndex
{
    if(comboBox == gameListBox) {
        id theRecord;
        theRecord = [games_list objectAtIndex:rowIndex];
        return [theRecord objectForKey:@"game_full_name"];
    }

}

- (id)tableView:(NSTableView *)aTableView 
    objectValueForTableColumn:(NSTableColumn *)aTableColumn
    row:(int)rowIndex
{
    if(aTableView == tableView) {
    id theRecord, theValue;
    NSParameterAssert(rowIndex >= 0 && rowIndex < [games count]);
    theRecord = [games objectAtIndex:rowIndex];
    theValue = [theRecord objectForKey:[aTableColumn identifier]];
    return theValue;
    
    }
    else if(aTableView == rulesView) {
        id theRecord, theValue;
        NSParameterAssert(rowIndex >= 0 && rowIndex < [rules count]);
        theRecord = [rules objectAtIndex:rowIndex];
        theValue = [theRecord objectForKey:[aTableColumn identifier]];
        return theValue;
    }
    else if(aTableView == playersView) {
        id theRecord, theValue;
        NSParameterAssert(rowIndex >= 0 && rowIndex < [players count]);
        theRecord = [players objectAtIndex:rowIndex];
        theValue = [theRecord objectForKey:[aTableColumn identifier]];
        return theValue;
    }
    else if(aTableView == favoritesView) {
        id theRecord, theValue;
        NSParameterAssert(rowIndex >= 0 && rowIndex < [favorites count]);
        theRecord = [favorites objectAtIndex:rowIndex];
        theValue = [theRecord objectForKey:[aTableColumn identifier]];
        return theValue;
    }
    
}

@end
